/*

    file:   sound h
    desc:   Sound sequencer header 

    author: Jaromir Dvorak (md@unicode cz)

    This file is part of the AVGA engine.
 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
*/


#ifndef _SOUND_H_
#define _SOUND_H_

#include "../config_hw.h"
#include "../config_sound.h"



/* ########## BEGIN OF USER CONFIGURABLE SECTION ########## */
#ifndef SOUND_HWCONFIG
#define SOUND_HWCONFIG

//
// Register that defines the timer's period
//
#define SOUND_TIMER_TOP			OCR2A

//
// audio output port
//
#define SOUND_TIMER_PORT		PORTD
#define SOUND_TIMER_DDR			DDRD
#define SOUND_TIMER_DDR_PIN		3

//
// audio timer setup
//
#define __sound_stop_timer()	OCR2A = 0
#define __sound_init_timer()	OCR2B = 1; 		\
				TCCR2A = 0x12;	\
				TCCR2B = 0x05;
#endif
/* ########### END OF USER CONFIGURABLE SECTION ########### */





#define SOUND_FRAMEHANDLE
//#define SOUND_LINEHANDLE



void inline sound_frame_handle();
void inline sound_line_handle();

void sound_init();
void sound_play(PGM_P sndfile);
void sound_stop();

#define audio_init()			sound_init()
#define audio_play(sndfile) 	sound_play(sndfile)
#define sound_stop()			sound_stop()



#endif

